<template>
  <div class="expertChoose">
    <div style="margin-bottom: 50px">
      <div style="display: flex;align-items: center">
        <span style="font-weight: 600">选用专家总人数：</span>
        <el-input
            clearable
            v-model.trim="queryParams.num"
            placeholder="请输入专家总人数"
            style="width: 150px;"
            @input="queryParams.num = queryParams.num.replace(/[^0-9]/g,'')"
            :disabled="!state.isAble || state.newProgress >=3 "

        >
        </el-input>
      </div>
      <div class="fTop">
        <div style="font-size: 16px;display: flex;align-items: center">
          专家组组长
          <el-icon style="margin-left: 10px;margin-right: 4px;margin-top: 2px;color: #FE8E8A"><InfoFilled /></el-icon>
          <span style="font-size: 14px;color: #FE8E8A">仅专家组组长允许固定选取，仅允许固定选取1人</span>
        </div>
        <el-button type="primary"  :disabled="state.info.step == 4 || state.isAdmin" style="width: 120px;margin-bottom: 10px" @click="chooseExpert('选取专家')">选取专家组组长</el-button>
      </div>
      <el-table v-loading="fLoading"  :data="fixedDataList" :border="true" ref="fTableRef" style="width: 100%;">
        <el-table-column label="姓名" prop="name" align="center" />
        <el-table-column label="性别" prop="sex" align="center" >
          <template #default="scope">
           {{scope.row.sex === 0 ? '男' : '女' }}
          </template>
        </el-table-column>
        <el-table-column label="身份证号" prop="idCard" align="center" />
        <el-table-column label="等级" prop="ratingLevel" align="center" >
          <template #default="scope">
            <span>{{scope.row.ratingLevel == 1 ?'一级':scope.row.ratingLevel == 1?'二级':'三级'}}</span>
          </template>
        </el-table-column>
        <el-table-column label="专业领域" prop="domain" align="center" />
        <el-table-column fixed="right" label="操作" align="center" class-name="small-padding fixed-width" width="180">
          <template #default="scope">
            <el-button link type="primary" @click="delF(scope.row)" :disabled="state.info.step == 4 || state.isAdmin">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div style="display: flex;flex-direction: column">
      <div style="display: flex;align-items: center">
        <span style="font-weight: 600">随机选用部分</span>
        <el-icon style="margin-left: 10px;margin-right: 4px;margin-top: 2px;color: #FE8E8A"><InfoFilled /></el-icon>
        <span style="font-size: 14px;color: #FE8E8A">随机人数为 {{queryParams.num-1}} 的5倍，可根据实际情况选取{{queryParams.num-1}} 人</span>
      </div>
      <el-form :model="queryParams" ref="queryForm" :inline="true" style="margin-top: 10px" label-width="90px">
        <el-row :gutter="24">
          <el-col :span="8">
            <el-form-item label="专业领域:">
              <el-cascader
                  style="width: 100%"
                  v-model="expertType"
                  :options="domainList"
                  :props="{ expandTrigger: 'hover',value: 'classifyName',label: 'classifyName',multiple: true }"
                  @change="professionChange"
                  collapse-tags
                  collapse-tags-tooltip
                  clearable
              >
              </el-cascader>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="允许级别:">
              <el-checkbox-group v-model="queryParams.ratingLevel" >
                <el-checkbox v-for="item in state.levelList" :label="item.id" :key="item.id">{{ item.name }}</el-checkbox>
              </el-checkbox-group>

            </el-form-item>
          </el-col>

          <el-col :span="8">
            <el-form-item style="float: right;" v-if=" state.newProgress < 3  && state.isAble && Number(queryParams.num) !=1 && queryParams.num!=''">
              <el-button style="width: 100px;margin-right: -32px;"  :disabled="state.info.step == 4 || state.isAdmin" type="primary" @click="random">随机抽取</el-button>
            </el-form-item>
          </el-col>
        </el-row>
        <div style="display: flex;align-items: center;justify-content: flex-end;margin-top: -15px;margin-bottom: 10px" v-if="state.newProgress < 3">
          <el-icon style="margin-left: 10px;margin-right: 4px;color: #FE8E8A"><InfoFilled /></el-icon>
          <span style="font-size: 14px;color: #FE8E8A">最多可随机3次，剩余{{3-state.randomNum}}次</span>
        </div>
<!--        <el-row :gutter="24">-->
<!--          <el-col :span="24">-->
<!--            <el-form-item label="拟选用人数:">-->
<!--              <el-input-->
<!--                  clearable-->
<!--                  v-model.trim="queryParams.num"-->
<!--                  placeholder="请输入拟选用人数"-->
<!--                  @input="queryParams.num = queryParams.num.replace(/[^0-9]/g,' ')"-->
<!--              >-->
<!--              </el-input>-->
<!--            </el-form-item>-->
<!--          </el-col>-->
<!--        </el-row>-->
      </el-form>
      <el-table v-loading="rLoading"  :data="randomDataList" :border="true" ref="rTableRef" style="width: 100%;" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" />
        <el-table-column label="姓名" prop="name" align="center" />
        <el-table-column label="性别" prop="sex" align="center" >
          <template #default="scope">
            {{scope.row.sex === 0 ? '男' : '女' }}
          </template>
        </el-table-column>
        <el-table-column label="身份证号" prop="idCard" align="center" />
        <el-table-column label="等级" prop="ratingLevel" align="center" >
          <template #default="scope">
           <span>{{scope.row.ratingLevel == 1 ?'一级':scope.row.ratingLevel == 2?'二级': scope.row.ratingLevel == 3?'三级' :'' }}</span>
          </template>
        </el-table-column>
        <el-table-column label="专业领域" prop="domain" align="center" />
<!--        <el-table-column fixed="right" label="操作" align="center" class-name="small-padding fixed-width" width="180">-->
<!--          <template #default="scope">-->
<!--            <el-button link type="primary" @click="delR(scope.row)" :disabled="state.info.step == 4 || state.isAdmin">删除</el-button>-->
<!--          </template>-->
<!--        </el-table-column>-->
      </el-table>
    </div>
    <experts-list ref="expertsListRef" @getName="getSelected"></experts-list>
  </div>
</template>

<script setup>
import {onMounted, onUnmounted, reactive, ref, watch} from "vue";
import expertsList from './expertsList.vue'
import {getExpertTypes} from "@/api/form";
import {ElMessage} from "element-plus";
import {addProject, choose, expertRound, getCheckInfo, getProjectInfo} from "@/api/projectManage";
import Cookies from "js-cookie";

const emit = defineEmits(["getNextStatus"]);
const fTableRef  = ref(null);
const expertsListRef = ref(null)
const fLoading = ref(false);
const rLoading = ref(false);
const fixedDataList = ref([]);
const rTableRef  = ref(null);
const randomDataList = ref([]);
const queryParams = reactive({
  num: null,
  ratingLevel: [],
  domain: null

})
const expertType = ref([])
const checkList = ref([])
const domainList = ref([])
const prop = defineProps(['projectId','newProgress'])
const state = reactive({
  formData: {
    id:null,
    step: 2,
    saveData: [],
    delData: []
  },
  info: {},
  levelList: [
    {
      id: 1,
      name: '一级'
    },
    {
      id: 2,
      name: '二级'
    },
    {
      id: 3,
      name: '三级'
    },
  ],
  isAdmin: false,
  projectId: null,
  newProgress: null,
  randomNum:0,
  isAble: true
})
const choosedRandomList = ref([])
const userInfo = ref()
onMounted(async () =>{
  // localStorage.removeItem('numData')
  // localStorage.removeItem('fixedDataList')
  // localStorage.removeItem('randomNum')

  if(prop.projectId){
    state.projectId = prop.projectId
    await getProjectProcess()
  }
  const fixListData = localStorage.getItem('fixedDataList');
  let fixDataArr = []
  if(fixListData){
    fixDataArr = JSON.parse(fixListData)
    fixDataArr.forEach(item => {
      if(item.projectId == state.projectId){
        fixedDataList.value = [item.fixedData]
      }
    })
  }
  const rondomData = localStorage.getItem('randomDataList');
  let rondomDataArr = []
  if(rondomData){
    rondomDataArr = JSON.parse(rondomData)
    rondomDataArr.forEach(item => {
      if(item.projectId == state.projectId){
        randomDataList.value = item.rondomData

      }
    })
  }
  const numData = localStorage.getItem('numData')
  let numDataArr = []
  if(numData){
    numDataArr = JSON.parse(numData)
    numDataArr.forEach(item => {
      if(item.projectId == state.projectId){
        queryParams.num = item.num
      }
    })
  }
  const randomNumData = localStorage.getItem('randomNum')
  let randomNumArr = []
  if(randomNumData){
    randomNumArr = JSON.parse(randomNumData)
    randomNumArr.forEach(item => {
      if(item.projectId == state.projectId){
        state.randomNum = Number(item.randomNum)
      }
    })
  }
  if(state.randomNum == 3){
      state.isAble = false
  }
  userInfo.value = JSON.parse(Cookies.get('userInfo'))
  state.isAdmin = userInfo.value.admin
  await getDomain()
})

const getProjectProcess  = async () => {
  const res = await getProjectInfo(state.projectId)
  if(res.code === 200) {
    state.newProgress = res.data.step
  }else {
    ElMessage.warning(res.message)
  }
}


watch(()=> fixedDataList.value,(newVal)=> {
  if(newVal && newVal.length>0){
    const data = {
      projectId :state.projectId,
      fixedData: newVal[0]
    }
    if(state.newProgress < 2){
      saveObjectToLocalStorage('fixedDataList',data)
    }
  }
})
watch(()=> randomDataList.value,(newVal)=> {
  if(newVal && newVal.length>0){
    const data = {
      projectId :state.projectId,
      rondomData: newVal
    }
    if(state.newProgress < 2){
      saveObjectToLocalStorage('randomDataList',data)
    }

  }
})
watch(()=> queryParams.num,(newVal)=> {
  if(newVal){
    const data = {
      projectId :state.projectId,
      num: newVal
    }
    if(state.newProgress < 2){
      saveObjectToLocalStorage('numData',data)
    }

  }
})

const saveObjectToLocalStorage = (key, newObj) => {
  const storedData = localStorage.getItem(key);
  let dataArray = [];
  if (storedData) {
    try {
      dataArray = JSON.parse(storedData);
    } catch (e) {
      console.error('数据解析失败，重置为空数组');
    }
  }
    const index = dataArray.findIndex(obj => obj.projectId == newObj.projectId)
    if(index !== -1){
      dataArray[index] = newObj
    }else {
      dataArray.push(newObj);
    }
  // 将数组转为字符串并存储到 localStorage
  localStorage.setItem(key, JSON.stringify(dataArray));
}


const riskOpen = async (type,val) => {
  console.log("type",type,val)
  state.projectId = val
  await getProjectProcess()
  if(type === 'add' || type === 'clickEdit'){
    if (state.isAdmin) {
      ElMessage.warning("当前用户暂无权限");
      return;
    }
    if(fixedDataList.value.length === 0){
      ElMessage.warning('请选择专家组组长')
      return;
    }
    // if(randomDataList.value.length < Number(queryParams.num)-1){
    //   ElMessage.warning('请随机抽取专家')
    //   return;
    // }
  }
  //保存按钮
  if(type === 'add'){
    let fData = []
    let rData = []
    //成功后自动到下一步 项目id
    const {...data} = state.formData
    data.id = val
    if(fixedDataList.value && fixedDataList.value.length > 0){
      fData = fixedDataList.value.map(item => {
        return {
          expertId: item.id,
          expertName:item.name,
          selectionMode: 1,
          teamLeader: 1
        }
      })
    }

    if(choosedRandomList.value && choosedRandomList.value.length > Number(queryParams.num) - 1){
      ElMessage.warning(`仅可选取${Number(queryParams.num) - 1}名随机专家`);
      return
    }
    if(choosedRandomList.value.length < Number(queryParams.num) - 1){
      ElMessage.warning(`随机专家数不能低于${Number(queryParams.num) - 1}人`)
      return
    }
    if(choosedRandomList.value && choosedRandomList.value.length > 0){
      rData = choosedRandomList.value.map(item => {
        return {
          expertId: item.id,
          expertName:item.name,
          selectionMode: 2,
          teamLeader: 0
        }
      })
    }
    data.saveData = fData.concat(rData)

    const res = await choose(data);
    if(res.code == 200){
      ElMessage.success('新增成功')
      emit('getNextStatus', val);
      removeLocal()
      // reset()
    }else{
      ElMessage.warning(res.message)
    }
  }else if(type === 'clickEdit'){
    let fData = []
    let rData = []
    const {...data} = state.formData
    data.id = val
    if(fixedDataList.value && fixedDataList.value.length > 0){
      fData = fixedDataList.value.map(item => {
        return {
          id: item.expertId ? item.id : '',
          expertId: item.expertId ? item.expertId : item.id,
          expertName:item.name,
          selectionMode: 1,
          teamLeader: 1
        }
      })
    }
    if(choosedRandomList.value && choosedRandomList.value.length > Number(queryParams.num) - 1){
      ElMessage.warning(`仅可选取${Number(queryParams.num) - 1}名随机专家`);
      return
    }
    if(choosedRandomList.value.length < Number(queryParams.num) - 1){
      ElMessage.warning(`随机专家数不能低于${Number(queryParams.num) - 1}人`)
      return
    }
    if(choosedRandomList.value && choosedRandomList.value.length > 0){
      rData = choosedRandomList.value.map(item => {
        return {
          expertId: item.id,
          expertName:item.name,
          selectionMode: 2,
          teamLeader: 0
        }
      })
    }
    data.saveData = fData.concat(rData)
    const res = await choose(data);
    if(res.code == 200){
      ElMessage.success('修改成功')
    }else{
      ElMessage.warning(res.message)
    }

  }else if(type === 'detail'){
    const param = {
      id: val
    }
    const res = await  getCheckInfo(param);
    if(res.code == 200){
      fixedDataList.value = res.data.projectExpertCheckResp.filter(item => item.selectionMode === 1)
      randomDataList.value = res.data.projectExpertCheckResp.filter(item => item.selectionMode === 2)
      state.info = res.data
      console.log('res',fixedDataList.value)
      queryParams.num = res.data.expertNum
      removeLocal()
    }else{
      ElMessage.warning(res.message)
    }
  }
}

const chooseExpert = (type) => {
  // if(fixedDataList.value && fixedDataList.value.length >0){
  //   ElMessage.warning('只能选择一个组长')
  //   return
  // }
  expertsListRef.value.openDialog(type,fixedDataList.value,domainList.value)
}

const removeLocal = () => {
  const fData = localStorage.getItem('fixedDataList');
  const rData = localStorage.getItem('randomDataList')
  const nData = localStorage.getItem('numData')
  const rnData = localStorage.getItem('randomNum')
  let fDataArray = [];
  let rDataArray = []
  let nDataArray = []
  let rnDataArray = []
  if (fData) {
    try {
      fDataArray = JSON.parse(fData);
    } catch (e) {
      console.error('数据解析失败，重置为空数组');
    }
  }
  const index = fDataArray.findIndex(obj => obj.projectId == state.projectId)
  if(index !== -1){
    fDataArray.splice(index,1)
  }
  localStorage.setItem('fixedDataList', JSON.stringify(fDataArray));

  if (rData) {
    try {
      rDataArray = JSON.parse(rData);
    } catch (e) {
      console.error('数据解析失败，重置为空数组');
    }
  }
  const indexR = rDataArray.findIndex(obj => obj.projectId == state.projectId)
  if(indexR !== -1){
    rDataArray.splice(indexR,1)
  }
  localStorage.setItem('randomDataList', JSON.stringify(rDataArray));

  if (nData) {
    try {
      nDataArray = JSON.parse(nData);
    } catch (e) {
      console.error('数据解析失败，重置为空数组');
    }
  }
  const indexN = nDataArray.findIndex(obj => obj.projectId == state.projectId)
  if(indexN !== -1){
    nDataArray.splice(indexN,1)
  }
  localStorage.setItem('numData', JSON.stringify(nDataArray));

  // if (rnData) {
  //   try {
  //     rnDataArray = JSON.parse(rnData);
  //   } catch (e) {
  //     console.error('数据解析失败，重置为空数组');
  //   }
  // }
  // const indexRN = rnDataArray.findIndex(obj => obj.projectId == state.projectId)
  // if(indexRN !== -1){
  //   rnDataArray.splice(indexRN,1)
  // }
  // localStorage.setItem('randomNum', JSON.stringify(rnDataArray));
}
const handleSelectionChange = (val) => {
  choosedRandomList.value = val
}

const getSelected = (type,data)=>{
  const selectData = JSON.parse(JSON.stringify(data))
  // if(fixedDataList.value && fixedDataList.value.length > 0){
  //   fixedDataList.value.forEach(item => {
  //     if(item.expertId){
  //       selectData.forEach((i,index) => {
  //         if(i.id == item.expertId){
  //           selectData[index] = item
  //         }
  //       })
  //     }
  //   })
  // }
  if(fixedDataList.value && fixedDataList.value.length >0){
    state.formData.delData.push(fixedDataList.value[0].id)
  }

  fixedDataList.value = selectData
}
const delF = (val) => {
  if(val.expertId){
    state.formData.delData.push(val.id)
  }
  fixedDataList.value = fixedDataList.value.filter(item => item.id != val.id)
}

const delR = (val) => {
  if(val.expertId){
    state.formData.delData.push(val.id)
  }
   const arr = randomDataList.value.filter(item => item.id != val.id)
  if(arr.length < queryParams.num-1){
    ElMessage.warning(`随机专家数不能低于${queryParams.num-1}人`)
    return
  }else {
    randomDataList.value = arr
  }


}
const professionChange=(value)=> {
  queryParams.domain = value.map(item => item[1])
}
const getDomain = async () => {
  const res = await getExpertTypes()
  if(res.code == 200){
    domainList.value = res.data
  }else{
    ElMessage.warning(res.message)
  }
}

const random = async () => {
  console.log('11',randomDataList.value)
  randomDataList.value.forEach(item => {
    if(item.expertId){
      state.formData.delData.push(item.id)
    }
  })
  if(fixedDataList.value && fixedDataList.value.length <= 0){
    ElMessage.warning('请先选择专家组组长')
    return
  }
  if(queryParams.domain == undefined ||  (queryParams.domain && queryParams.domain.length == 0)){
    ElMessage.warning('专业领域不能为空')
    return
  }
  if(queryParams.num =='' || queryParams.num == undefined){
    ElMessage.warning('选用专家总人数不能为空')
    return
  }
  rLoading.value = true
  const param = {
    num: (Number(queryParams.num)-1) * 5,
    selectedUserId: fixedDataList.value[0].id,
    domain: queryParams.domain,
    ratingLevel:queryParams.ratingLevel
  }
  const res = await expertRound(param)
  if(res.code == 200){
    randomDataList.value = res.data
    state.randomNum = state.randomNum + 1
    const obj = {
      projectId: state.projectId,
      randomNum: state.randomNum
    }
    saveObjectToLocalStorage('randomNum',obj)
    if(state.randomNum == 3){
      state.isAble = false
    }
  }else{
    ElMessage.warning(res.message)
  }
  rLoading.value = false
}

defineExpose({
  riskOpen
});
</script>


<style scoped lang="scss">
.expertChoose{
  display: flex;
  flex-direction: column;
  .fTop{
    display: flex;
    align-items: center;
    justify-content: space-between;
    margin-bottom: 0px;
  }

}
</style>
